% INIT.m Inizializza parametri esempio 1 (scambiatore a liquido)

global tau tau_i tau_m lambda_im tau_1 alfa_0 alfa_i
global Kp Ti

N = 100 % numero tubi
L = 1 % lunghezza
D = 0.01 % diametro
s = 0.001 % spessore
w = 0.1 % portata

Ti = 40 % temperatura ingresso
Te = 100 % temperatura esterna

ro = 1000
c = 4200
ro_m = 7800
c_m = 600

gamma_i = 2000
gamma_e = 100

omega_i = N*D*pi
omega_e = N*(D+2*s)*pi
A = N*(D/2)^2*pi
A_m = N*(D/2+s)^2*pi-A
M = ro*A*L
M_m = ro_m*A_m*L

Y_im = gamma_i*omega_i*L
Y_me = gamma_e*omega_e*L
Y_t = 1/(1/Y_im+1/Y_me)

alfa_0 = Y_t/(w*c)
alfa_i = Y_im/(w*c)
tau = M/w
tau_1 = (M_m*c_m)/(w*c)
mu_0 = exp(-alfa_0)

Tu = mu_0*Ti + (1-mu_0)*Te

omega_c = 50/180*pi/(tau+tau_1)
Ti = 1/(4*omega_c)
Kp = omega_c*Ti/mu_0

% range frequenze diagrammi di Bode anello aperto
w1=1e-2;
w2=2e0;

% range frequenze diagrammi di Bode funzione d'anello
w1cl = 1e-3;
w2cl = 1e-1;

% approssimazione tutti poli di GTi'
n = round(alfa_i/2);
T = tau_1/n;
num = mu_0;
den = 1;
for i = 1:n
   den = conv(den,[T 1]);
end

