% Calcola risposte in frequenza scambiatore 1

% Calcolo risposta del processo G_Ti1(jw) (depurata ritardo puro tau)
[w,G_Ti1_jw]=bode2('G_Ti1',w1,w2);
G_Ti1p_jw=G_Ti1p(j*w); % approssimazione tutti poli
G_Ti1r_jw=G_Ti1r(j*w); % approssimazione ritardo puro

% Calcolo risposta del processo G_Ti(jw) (incluso ritardo puro tau)
G_Ti_jw=G_Ti1_jw.*exp(-tau*j*w);
G_Tip_jw=G_Ti1p_jw.*exp(-tau*j*w);% approssimazione tutti poli
G_Tir_jw=G_Ti1r_jw.*exp(-tau*j*w);% approssimazione ritardo puro

% Visualizzazione
close all
% Diagrammi Bode open loop
figure(1);
subplot(211)
semilogx(w,db(G_Ti1_jw),'k',w,db(G_Ti1p_jw),'b',w,db(G_Ti1r_jw),'r')
legend('G''_{Ti}(jw)', 'G''_{Tip}(jw)', 'G''_{Tir}(jw)',2)
title('Diagrammi Bode G''_{Ti}(s)')
xlabel('Pulsazione [rad/s]');
ylabel('Modulo [dB]');
grid on
% set(gca,'XTickMode','manual')
% set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])

subplot(212)
semilogx(w,fase(G_Ti1_jw),'k',w,fase(G_Ti1p_jw),'b',w,fase(G_Ti1r_jw),'r')
legend('G''_{Ti}(jw)', 'G''_{Tip}(jw)', 'G''_{Tir}(jw)',2)
xlabel('Pulsazione [rad/s]');
ylabel('Fase [gradi]');
set(gca,'YTickMode','manual')
set(gca,'YTick',[-180 -90 0 90 180])
grid on

figure(2);
subplot(211)
semilogx(w,db(G_Ti_jw),'k',w,db(G_Tip_jw),'b',w,db(G_Tir_jw),'r')
legend('G_{Ti}(jw)', 'G_{Tip}(jw)', 'G_{Tir}(jw)',2)
title('Diagrammi Bode G_{Ti}(s)')
xlabel('Pulsazione [rad/s]');
ylabel('Modulo [dB]');
grid on
% set(gca,'XTickMode','manual')
% set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])

subplot(212)
semilogx(w,fase(G_Ti_jw),'k',w,fase(G_Tip_jw),'b',w,fase(G_Tir_jw),'r')
legend('G_{Ti}(jw)', 'G_{Tip}(jw)', 'G_{Tir}(jw)',2)
xlabel('Pulsazione [rad/s]');
ylabel('Fase [gradi]');
set(gca,'YTickMode','manual')
set(gca,'YTick',[-180 -90 0 90 180])
grid on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Calcolo funzioni d'anello

% Calcolo risposta del processo G_Ti1(jw) (depurata ritardo puro tau)
[w,G_Ti1_jw]=bode2('G_Ti1',w1cl,w2cl);
G_Ti1p_jw=G_Ti1p(j*w); % approssimazione tutti poli
G_Ti1r_jw=G_Ti1r(j*w); % approssimazione ritardo puro

% Calcolo risposta del processo G_Ti(jw) (incluso ritardo puro tau)
G_Ti_jw=G_Ti1_jw.*exp(-tau*j*w);
G_Tip_jw=G_Ti1p_jw.*exp(-tau*j*w);% approssimazione tutti poli
G_Tir_jw=G_Ti1r_jw.*exp(-tau*j*w);% approssimazione ritardo puro

% Calcolo risposta regolatore
R_jw=R_PI(j*w);

% Calcolo funzioni d'anello corrispondenti
L_jw  = R_jw.*G_Ti_jw;
Lp_jw = R_jw.*G_Tip_jw;
Lr_jw = R_jw.*G_Tir_jw;

% Visualizzazione diagrammi Bode funzione d'anello

figure(3);
subplot(211)
semilogx(w,db(L_jw),'k',w,db(Lp_jw),'b',w,db(Lr_jw),'r')
legend('L(jw)', 'L''_{p}(jw)', 'L''_{r}(jw)',2)
title('Diagrammi Bode L(s)')
xlabel('Pulsazione [rad/s]');
ylabel('Modulo [dB]');
grid on
% set(gca,'XTickMode','manual')
% set(gca,'XTick',[.01:.01:.1 .2:.1:1 2:10])

subplot(212)
semilogx(w,fase(L_jw),'k',w,fase(Lp_jw),'b',w,fase(Lr_jw),'r')
legend('L(jw)', 'L_{p}(jw)', 'L_{r}(jw)',2)
xlabel('Pulsazione [rad/s]');
ylabel('Fase [gradi]');
set(gca,'YTickMode','manual')
set(gca,'YTick',[-180 -90 0 90 180])
grid on

